jQuery.noConflict();

(function($, PLUGIN_ID) {
    "use strict";

    $(document).ready(function() {
        kintone.api(kintone.api.url('/k/v1/preview/form', true), 'GET', {'app': kintone.app.getId()}, function(resp) {
            var config = kintone.plugin.app.getConfig(PLUGIN_ID);
            config['account_sid'] && ($('#account_sid').val(config['account_sid']));
            config['auth_token'] && ($('#auth_token').val(config['auth_token']));
            config['from_dial'] && ($('#from_dial').val(config['from_dial']));
            config['from_sms'] && ($('#from_sms').val(config['from_sms']));
            $.each(resp['properties'], function(index, property) {
                if (property['type'] === 'SINGLE_LINE_TEXT') {
                    $('#twilio-plugin-message-field').append($('<OPTION>').html(property['label']).val(property['code']));
                    $('#twilio-plugin-tel-field').append($('<OPTION>').html(property['label']).val(property['code']));
                }
            });
            config['tel_field'] && ($('#twilio-plugin-tel-field').val(config['tel_field']));
            config['message_field'] && ($('#twilio-plugin-message-field').val(config['message_field']));
        });

        $('#twilio-plugin-submit').click(function() {
            var accountSid = $('#account_sid').val();
            var authToken = $('#auth_token').val();
            var fromDial = $('#from_dial').val();
            var fromSms = $('#from_sms').val();
            if (accountSid == null || accountSid.length == 0 ) {
                alert('AccountSid が入力されていません。');
                return;
            }
            if (authToken == null || authToken.length == 0) {
                alert('AuthToken が入力されていません。');
                return;
            }
            if (fromDial.length > 0 && (!fromDial.replace(/ /g, "").replace(/　/g, "").match(/^[-\+0-9]+$/) || fromDial.length > 20)) {
                alert('ダイアル発信元電話番号に使用できない文字が入力されています。入力値を確認してください。');
                return;
            }
            if (fromSms.length > 0 && (!fromSms.replace(/ /g, "").replace(/　/g, "").match(/^[-\+0-9]+$/) || fromSms.length > 20)) {
                alert('SMS送信元電話番号に使用できない文字が入力されています。入力値を確認してください。');
                return;
            }
            var config = {};
            config['account_sid'] = accountSid;
            config['auth_token'] = authToken;
            config['from_dial'] = fromDial.replace(/ /g, "").replace(/　/g, "");
            config['from_sms'] = fromSms.replace(/ /g, "").replace(/　/g, "");
            config['message_field'] = $('#twilio-plugin-message-field').val();
            config['tel_field'] = $('#twilio-plugin-tel-field').val();

            kintone.plugin.app.setConfig(config);
        });
        
        $('#twilio-plugin-cancel').click(function() {
            history.back();
        });
    });
})(jQuery, kintone.$PLUGIN_ID);
